searchData={"items":[{"type":"module","title":"Injexor","doc":"Injexor provides an easy way to replace modules based on behaviours\nfor mocking during tests or stubbing in another module based on config.\n\nThis allows go to definition and auto complete to continue to function for dev.\n\nSpecified modules are only replaced in function calls that are defined as a callback.\n\nThere are two ways to define an injected module, first is by using the `:inject` opt passed to `use`.\nIt can be either a single module or a list.\n\n```\nuse Injexor, otp_app: :my_app, inject: MyApp.Repo\nuse Injexor, otp_app: :my_app, inject: [MyApp.Repo, MyApp.Repo]\n```\n\nYou can also explicitly tell it what behaviour to use in the case where a module may have many.\n\n```\nuse Injexor, otp_app: :my_app, inject: {MyApp.Repo, MyApp.Repo.Behaviour}\n```\n\nThe other way is to define `@inject` attribute above a function def. `@inject` also accepts either\na single module or a list. This should only be used when you want to affect a single function.\n\n```\nuse Injexor, otp_app: :my_app\n\nalias MyApp.Repo\n\n@inject Repo\ndef get(id) do\n  Repo.get(id)\nend\n```\n\nThen you can call the module as normal in your code and use mox/hammox in your tests.\n\n`otp_app` is used to look up the module to inject in.\n\nFor example for `use Injexor, otp_app: :my_app, inject: MyApp.Repo`, the macro will lookup the module\nto inject with `Application.get_env(:my_app, MyApp.Repo)`. In testing this will default to\n`MyApp.Team.Mock` if not specified in config, otherwise the default is the module itself.","ref":"Injexor.html"},{"type":"module","title":"Injexor.Hooks","doc":"","ref":"Injexor.Hooks.html"},{"type":"extras","title":"Injexor","doc":"# Injexor\n\n**TODO: Add description**","ref":"readme.html"},{"type":"extras","title":"Installation - Injexor","doc":"If [available in Hex](https://hex.pm/docs/publish), the package can be installed\nby adding `injexor` to your list of dependencies in `mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:injexor, \"~> 0.1.0\"}\n  ]\nend\n```\n\nDocumentation can be generated with [ExDoc](https://github.com/elixir-lang/ex_doc)\nand published on [HexDocs](https://hexdocs.pm). Once published, the docs can\nbe found at  .","ref":"readme.html#installation"},{"type":"extras","title":"Changelog","doc":"0.1.0\n------\n#### Changes\n- First version","ref":"changelog.html"}],"content_type":"text/markdown","producer":{"name":"ex_doc","version":[48,46,51,51,46,48]}}